// SRAMANZXpȈՊ֐

#ifndef sram_rw_h
#define sram_rw_h

// ݏ́Asram_startwritesram_endwrite̊ԂɏƁB
// sram_endwriteŏIȂƃf[^ǂݏoȂcȂȂǂB

/* ȕɎgB
  u32 a,b;
  
  if(sram_isFirstBoot()==True){
    // N͏lݒ
    a=0;
    b=0;
    }else{
    // xڈȍ~imɂ͈xłwriteꂽjSRAMǂݍ
    a=sram_read32(0);
    b=sram_read32(1);
  }
  
  FXăZ[uiKɂȂB

  {
    sram_startwrite();
    sram_write32(0,a);
    sram_write32(1,b);
    sram_endwrite();
  }
  
  OKBϒƂ͂Ȃ̂ŖBKsize(8bit)+data(var)ƂH
*/

#define SRAM_FirstBootFlag *(volatile u16*)0xE000000
u8 *SRAM_Data=(u8*)0xE000001;

b8 sram_isFirstBoot(void)
{
  // قƂɏN0x00x^ۏ؂̂킩Ȃ0xffȊOSĒeBłsB
  // NSELECT{^ĂSRAM邩ǂj[ł悤ɂƂ񂶂Ȃ̂ȁ[B

  if(SRAM_FirstBootFlag!=0xff){
    SRAM_FirstBootFlag=0x00;
    return(True);
    }else{
    return(False);
  }
}

void sram_startwrite(void)
{
  SRAM_FirstBootFlag=0x00;
}

void sram_endwrite(void)
{
  SRAM_FirstBootFlag=0xff;
}

void sram_write8(u32 adr,u8 v)
{
  SRAM_Data[adr*4+0]=0x00;
  SRAM_Data[adr*4+1]=0x00;
  SRAM_Data[adr*4+2]=0x00;
  SRAM_Data[adr*4+3]=v;
}

u8 sram_read8(u32 adr)
{
  return(SRAM_Data[adr*4+3]);
}

void sram_write16(u32 adr,u16 v)
{
  SRAM_Data[adr*4+0]=0x00;
  SRAM_Data[adr*4+1]=0x00;
  SRAM_Data[adr*4+2]=(u8)(v>>8);
  SRAM_Data[adr*4+3]=(u8)v;
}

u16 sram_read16(u32 adr)
{
  return((((u16)SRAM_Data[adr*4+2])<<8)+
         ((u16)SRAM_Data[adr*4+3]));
}

void sram_write32(u32 adr,u32 v)
{
  SRAM_Data[adr*4+0]=(u8)(v>>24);
  SRAM_Data[adr*4+1]=(u8)(v>>16);
  SRAM_Data[adr*4+2]=(u8)(v>>8);
  SRAM_Data[adr*4+3]=(u8)v;
}

u32 sram_read32(u32 adr)
{
  return((((u32)SRAM_Data[adr*4+0])<<24)+
         (((u32)SRAM_Data[adr*4+1])<<16)+
         (((u32)SRAM_Data[adr*4+2])<<8)+
         ((u32)SRAM_Data[adr*4+3]));
}

#endif
